/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.sqoop.model;

import org.junit.Test;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 *
 */
public class TestMFramework {

  @Test
  public void testFailureOnDuplicateJobTypes() {
    MConnectionForms connectionForms = new MConnectionForms(new ArrayList<MForm>());
    List<MJobForms> jobForms = new ArrayList<MJobForms>();
    jobForms.add(new MJobForms(MJob.Type.IMPORT, new ArrayList<MForm>()));
    jobForms.add(new MJobForms(MJob.Type.IMPORT, new ArrayList<MForm>()));

    try {
      new MFramework(connectionForms, jobForms, "1");
      fail("We we're expecting exception for invalid usage");
    } catch(Exception ex) {
      // Expected case
    }
  }
}
